import * as controller from '../view/controller.js'
import * as browser from '../view/browser.js'
import * as queue from '../view/queue.js'
import * as entry from './entry.js'
import * as panel from './panel/panel.js'

export async function State() {
	await browser.State()
	await queue.State()
}

export function Init() {
	panel.Init()

	browser.Init()
	queue.Init()

	controller.Init()
}

export function PrevElement(focus) {
	return focus.previousElementSibling ?? focus.parentNode.lastElementChild
}

export function NextElement(focus) {
	return focus.nextElementSibling ?? focus.parentNode.firstElementChild
}

export {
	browser,
	queue,
	entry,
	controller,
	panel
}