const State = window.State ??= {}
const View = window.View ??= {}

import * as view from './view.js'

export function Init() {
	hiss.view.actions = {}
	
	{
		let _ = hiss.view.actions.menu = {}
	
		_['ArrowUp'] = {
			down() {
				view.FocusPrev()
			}
		}
		_['ArrowDown'] = {
			down() {
				view.FocusNext()
			}
		}
	}
	{
		let _ = hiss.view.actions.main = {}
	
		_['ArrowRight'] = _['ArrowLeft'] = {
			up() {
				view.Next()
			}
		}
	}

	window.addEventListener('keyup', (e) => OnKey(e, ActionUp))
	window.addEventListener('keydown', (e) => OnKey(e, ActionDown))
}

export function GetAction(key, element = view.Panel().focus) {
    let actionSet = element.dataset.actionSet && hiss.view.actions[element.dataset.actionSet]
	if(actionSet && actionSet[key]) {
		return actionSet[key]
	}
	let p = element.parentNode.closest('*[data-action-set]')
	if(p) {
		return GetAction(key, p)
	}
}

export function OnKey(event, callback) {
	let a = GetAction(event.key)
	if(a == null) return

	let failed = callback(a.shift && event.shiftKey ? a.shift : a)
	if(!failed) {
		event.preventDefault()
	}
}

export function ActionDown(action) {
	if(action.holdTimeout != null) {
		return true
	}

	if(action.down) {
		return action.down(focus)
	}

	if(action.hold) {
		Hold(action, element)
	} else if(action.press) {
		return action.press(focus)
	}
}

export function ActionUp(action) { 
	if(action.holdTimeout != null) {
		clearTimeout(action.holdTimeout)
		action.holdTimeout = null
	}

	if(action.up) {
		return action.up(focus)
	}

	if(action.heldCount > 0) {
		return action.press(focus)
	}
}

export function Hold(aAction) {
	aAction.heldCount = holdIntervals
	createHoldTimeout(aAction)
}

export function createHoldTimeout(aAction) {
	aAction.holdTimeout = setTimeout(() => {
		aAction.heldCount--
		if(aAction.heldCount == 0) {
			aaction.hold(focus)
		} else {
			createHoldTimeout(aAction)
		}
	}, holdIntervalLength)
}