import * as controller from "./controller.js"
import * as view from "./view.js"

export function Init() {
    hiss.view.queue = {
        root: document.getElementById('queue'),
        menu: document.getElementById('queue-menu'),
        focus: null
    }

    Render()
}

export function Render() {
    let menu = hiss.view.queue.menu

    let len = 0
    while (menu.firstChild) {
		menu.removeChild(menu.lastChild)
	}
    for(let i = 0; i < hiss.state.queue.length; i++) {
        let t = hiss.state.queue[i]
        len += t.duration
        menu.appendChild(renderTrack(t, i, len))
    }

    view.Focus(menu.children[0] ?? menu, hiss.view.queue)
}

export function Open() {
    Render()
}

export function renderTrack(eTrack, iIndex, fLength) {
    let li = document.createElement('li')
    let aside = document.createElement('aside')
    let timestamp = document.createElement('code')

    view.populateTrackInfo(eTrack, aside)
    timestamp.innerText = view.FormatTime(parseInt(fLength))

    li.appendChild(timestamp)
    li.appendChild(aside)

    li.dataset.actionSet = 'queue-track'
    li.dataset.index = iIndex

    return li
}